function nrmse = compute_error_8(estimatedOutput, correctOutput, esn)

% remark: estimatedOutput has size 
% (lengthTrainigData_minus_washout, dataSize, nOuts)

% nrmse has size (dataSize, nOuts)

% if length(correctOutput) > length(estimateOutput),  the first
% elements from correctOutput are deleted
nEstimatedPoints = size(estimatedOutput, 1) ; 
nForgetPoints = size(correctOutput,1) - nEstimatedPoints ; 
correctOutputShort = correctOutput(nForgetPoints+1:end,:,:) ; 

mse = squeeze(mean(((estimatedOutput - correctOutputShort).^2), 1)) ; % size (dataSize, nOuts)

variance = zeros(size(estimatedOutput,2), size(estimatedOutput,3)); % size (dataSize, nOuts)
for d = 1:size(estimatedOutput,3)
    for p = 1:size(estimatedOutput,2)
        variance(p,d) = var(correctOutputShort(:,p,d));
    end
end

nrmse = (sqrt(mse./variance)) ; 


