function stateCollectMat = compute_statematrix_8(sampleInput, sampleOutput, voteHistory, ...
    esn, nForgetInput, trainNoiseLevel)



nSampleInput = size(sampleInput,1);  
internalState = zeros(esn.reservoirSize, 1);
totalstate = zeros(esn.reservoirSize + esn.p, 1);
netOut = zeros(esn.p, esn.d);
stateCollectMat = zeros(nSampleInput-nForgetInput, esn.reservoirSize + esn.p) ; 
W = esn.W * esn.spectralRadius;
  
for iInput = 1:nSampleInput

    externalIn = sampleInput(iInput,:)'; %  is column vector
    in =  esn.inputScaling .* externalIn + esn.inputShift;
    
    voteState = [in netOut] * voteHistory(iInput,:)';
    voteState = esn.inputWeightScaling .* voteState + esn.bias;
    totalstate(esn.reservoirSize+1:end,1) = voteState;    
    
    internalState = feval(esn.reservoirActivationFunction, ...
    [W, esn.W_in] * totalstate );  
    internalState = internalState + trainNoiseLevel * (rand(esn.reservoirSize,1) - 0.5);
    
    % force teacher output   
    teacher = squeeze(sampleOutput(iInput, :,:));
    teacher = esn.teacherScaling .* teacher + esn.teacherShift;
    netOut = feval(esn.dataActivationFunction, teacher);

    totalstate(1:esn.reservoirSize) = internalState;
    
    %collect state
    if (iInput > nForgetInput)
        collectIndex = iInput - nForgetInput;
        stateCollectMat(collectIndex,:) = totalstate'; %fill a row
    end
end