function stateCollectMat = compute_statematrix_noTeacher_8(sampleInput, voteHistory, ...
    esn, nForgetInput)
 

nSampleInput = size(sampleInput,1);  
internalState = zeros(esn.reservoirSize, 1);
totalstate = zeros(esn.reservoirSize + esn.p, 1);
netOut = zeros(esn.p, esn.d);
stateCollectMat = zeros(nSampleInput-nForgetInput, esn.reservoirSize + esn.p) ; 
intWeights = esn.W * esn.spectralRadius;
  
for iInput = 1:nSampleInput

    externalIn = sampleInput(iInput,:)'; %  is column vector
    in =  esn.inputScaling .* externalIn + esn.inputShift;
    
    voteState = [in netOut] * voteHistory(iInput,:)';
    voteState = esn.inputWeightScaling .* voteState + esn.bias;
    totalstate(esn.reservoirSize+1:end,1) = voteState;    
    
    internalState = feval(esn.reservoirActivationFunction, ...
    [intWeights, esn.W_in] * totalstate );  

    totalstate(1:esn.reservoirSize,1) = internalState;
    
    netOut = zeros(esn.p, esn.d);
    for n = 1:esn.d
        netOut(:,n) = (esn.W_out(:,:,n) * totalstate);
    end
    netOut = feval(esn.dataActivationFunction, netOut);
    
    %collect state
    if (iInput > nForgetInput)
        collectIndex = iInput - nForgetInput;
        stateCollectMat(collectIndex,:) = totalstate'; %fill a row
    end
end