function plot_states(stateMatrix, states, nPoints, titlestring)
  
%PLOT_STATES plots the internal states of the esn
%example  : plot_states(stateMatrix,[1 2 3 4],200) plots the first 200
%points from the traces of the first 4 units

if (nargin < 3)
    nPoints = length(stateMatrix(:,1)) ; 
end

nStates = length(states) ; 

xMax = ceil(sqrt(nStates)) ; 
yMax = ceil(nStates /xMax);

for iPlot = 1 : nStates
    subplot(xMax,xMax,iPlot) ; 
    plot(stateMatrix(1:nPoints,iPlot));
    if iPlot == 1
        title(titlestring);
    end
end

