function [output, stateCollection] = test_esn_8(input,  voteHistory, esn, nForgetInput)
% test_esn_8 runs a trained ESN on a particular input
% output has size [size(input,1) esn.d esn.p]
% output contains the values of the output units *before* sigmoiding, with
% reversing teacherShift and teacherScaling
  
stateCollection = compute_statematrix_noTeacher_8(input, voteHistory, esn, nForgetInput) ; 

for n = 1:esn.d
    output(:,:,n) = feval(esn.dataActivationFunction, ...
    stateCollection * squeeze(esn.W_out(:,:,n))');
    output(:,:,n) = ...
        output(:,:,n) - repmat(esn.teacherShift(:,n)', size(stateCollection,1),1);
    output(:,:,n) = ...
        output(:,:,n)./ repmat(esn.teacherScaling(:,n)', size(stateCollection,1),1);
end


  
  