function [W_out, stateCollection, teacherCollection] = ...
    train_esn_8(sampleInput, sampleOutput, voteHistory, esn, nForgetOutput, trainNoiseLevel)
% TRAIN_ESN Trains the output weights of an ESN by performing a linear regression

% outputWeights = train_esn(stateCollection, teacherCollection)
  
% stateCollection is a nSamplePoints * nTotalUnits matrix that keeps all
% the traces from the individual units
% teacherCollection is a nSamplePoints * nOuputUnits matrix that keeps
% the expected output of the ESN  

stateCollection = compute_statematrix_8(sampleInput, sampleOutput, voteHistory, esn,...
    nForgetOutput , trainNoiseLevel) ; 
teacherCollection = compute_teacher_8(sampleOutput, esn, nForgetOutput) ; 
W_out = feval(esn.methodTrain, stateCollection, teacherCollection, esn)    ; 


  